<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004-2009 The Cacti Group                                 |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin
    Contact ........ www.cacti.net
    Home Site ...... http://www.cacti.net
    Program ........ banner "plugin banner"
    Version ........ 0.1
    Purpose ........ let appear a banner at the top of each plugins. Could be use to 
                     inform cacti user for maintenance, problem or some puplicity.
                     Need PA 3.x (plugin architecture 3.x)
*******************************************************************************/

function plugin_init_banner() {
	global $plugin_hooks;
	
//    $plugin_hooks['top_header_tabs']['banner'] = 'banner_show_tab';

}

/* plugin install - provides a generic PA 3.x installer routine to register all plugin hook functions.
*/
function plugin_banner_install() {
	
    global $config;

    if (version_compare($config['cacti_version'], '1.0.0') < 0) {
        return false;
    }
	
    $plugin = 'banner';
	
   api_plugin_register_hook('banner', 'top_header_tabs',       'banner_show_tab',             "setup.php");
   api_plugin_register_hook('banner', 'top_graph_header_tabs', 'banner_show_tab',             "setup.php");
   api_plugin_register_hook('banner', 'config_arrays',         'banner_config_arrays',        "includes/settings.php");
   api_plugin_register_hook('banner', 'draw_navigation_text',  'banner_draw_navigation_text', "includes/settings.php");
   api_plugin_register_hook('banner', 'config_form',           'banner_config_form',          "setup.php");
   api_plugin_register_hook('banner', 'config_settings',       'banner_config_settings',      "includes/settings.php");
   api_plugin_register_hook('banner', 'api_graph_save',        'banner_api_graph_save',       "setup.php");
   api_plugin_register_hook('banner', 'body_style', 'banner_api_plugin_hook_function_body_style', "setup.php");

   // register the realm for each php file
   api_plugin_register_realm('banner', 'banner.php', 'View banner', 1);

   #banner_setup_table_new ();
}

function plugin_banner_version()
{
    global $config;
    $info = parse_ini_file($config['base_path'] . '/plugins/banner/INFO', true);
    return $info['info'];
}

function banner_version()
{
    return plugin_banner_version();
}

/* plugin uninstall - a generic uninstall routine.  Right now it will do nothing as I
   If you don't want the tables removed from the system except let it empty. */
function plugin_banner_uninstall () {
	/* Do any extra Uninstall stuff here */
}

function plugin_banner_upgrade () {
	/* Here we will upgrade to the newest version */
//	banner_check_upgrade();
	return false;
}

function plugin_banner_check_config () {
        /* Here we will check to ensure everything is configured */
        return true;
}

# Not used function to create sql tables
#function banner_setup_table_new () {
#}

# Not used function to refresh the banner
#function banner_top_graph_refresh ($refresh) {
#        /* change the refresh time of your view. Here as example banner.php */
#        /* banner_refresh is supposed to be one parameter of the setting */
#        if (basename($_SERVER['PHP_SELF']) != 'banner.php')
#                return $refresh;
#        $r = read_config_option('banner_refresh');
#        if ($r == '' or $r < 1)
#                return $refresh;
#        return $r;
#}

function banner_show_tab () {
  global $config, $user_auth_realms, $user_auth_realm_filenames;
  $realm_id2 = 0;

  /*---- Begin of the minimal functions needed ----*/
  if (isset($user_auth_realm_filenames{basename('banner.php')})) {
                $realm_id2 = $user_auth_realm_filenames{basename('banner.php')};
  }
  if ((db_fetch_assoc("select user_auth_realm.realm_id
        from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
        and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

        if (substr_count($_SERVER["REQUEST_URI"], "banner.php")) {
                print '<a href="' . $config['url_path'] . 'plugins/banner/banner.php"><img src="' . $config['url_path'] . 'plugins/banner/images/tab_banner-green.png" alt="banner" align="absmiddle" border="0"></a>';
        }else{
                print '<a href="' . $config['url_path'] . 'plugins/banner/banner.php"><img src="' . $config['url_path'] . 'plugins/banner/images/tab_banner.png" alt="banner" align="absmiddle" border="0"></a>';
        }

  }
  /*---- End of the minimal functions needed ----*/

  /* now you can put your needs */
}

function banner_api_graph_save ($save) {
        /* what happend after a click on the save button */
}

function banner_api_plugin_hook_function_body_style () {
   global $config;
   $banneractivation = 0;
   $show_console_tab = 1;
   $banneractivation = read_config_option("banneractivation");
   $show_console_tab = api_user_realm_auth('settings.php');
   if ($banneractivation) {
	 $selectedTheme = get_selected_theme();
     print ">\n";
	 if (($selectedTheme == 'dark') || ($selectedTheme == 'modern')) {
		print "<BR><BR><BR><BR>\n";   
	 }
     print "<table>\n";
     print "<tr>";
     if (is_file("./plugins/banner/banner_top_header.php")) {
        include_once("./plugins/banner/banner_top_header.php");
     }
	 if (($selectedTheme == 'dark') || ($selectedTheme == 'modern')) {
		print "<td style='width:300px'></td>";
	 } 
     print "<td>";
     bannerMessage(false,$show_console_tab);
     print "</td>";
     print "</tr>";
     print "</table>";
     print "\n<!-- comment to  close properly body cacti --";
   }
}

?>
